package edu.umich.visualsoar.parser;

public class Triple {
	// DataMembers
	Pair d_variable;
	Pair d_attribute;
	Pair d_value;
	boolean d_hasState = false;
	int d_line;

	// NOT IMPLEMENTED
	private Triple() {}
	
	// Constructors
	public Triple(Pair variable,Pair attribute,Pair value) {
		d_variable = variable;
		d_attribute = attribute;
		d_value = value;
	}
	
	public Triple(Pair variable,Pair attribute,Pair value, boolean hasState) {
		this(variable,attribute,value);
		d_hasState = hasState;
	}
	
	// Accessors
	public boolean hasState() {
		return d_hasState;
	}
	
	public Pair getVariable() {
		return d_variable;
	}
	
	public Pair getAttribute() {
		return d_attribute;
	}
	
	public Pair getValue() {
		return d_value;
	}
	
	public int getLine() {
		if(d_value.getLine() != -1)
			return d_value.getLine();
		else if(d_attribute.getLine() != -1)
			return d_attribute.getLine();
		else
			return d_variable.getLine();
	}
	
	public String toString() {
		return "(" + d_variable.getString() + "," + d_attribute.getString() + "," + d_value.getString() + ")";
	}
}
