@rem
@rem Run with make-all-windows <version> where e.g. <version> = 020
@rem Results are copied into Releases folder.
@rem

@rem Save the initial value of some env vars
@set svpath=%path%
@set svinc=%include%
@set svlib=%lib%

@rem Check if a version was provided
@IF "%1" == "" goto Help1
@set ver=%1%

@rem Set up the ROOT, VC6 and JDK env vars if needed
call windows-env.bat

@IF "%VC6%" == "" goto help2
@IF "%JDK%" == "" goto help2
@IF "%RELEASES%" == "" goto help2
@IF "%TCL%" == "" goto help2

@rem Set debug/release configuration here
set config=Release

@rem Set the soar version (used to find the soar files)
@set soarver=Soar-8.3

@rem Create the output directory (removing the existing one if needed)
@set output=%RELEASES%\V%ver%-Windows
rmdir /s /q "%OUTPUT%"
mkdir "%OUTPUT%"

@rem Set up the include path etc. for VC++ 6
@call "%VC6%\vc98\bin\vcvars32.bat"
@echo on

@rem Set up the include path etc. for JDK
@path=%path%;%JDK%\bin

@rem Set up the include path etc. for TCL
set INCLUDE=%include%;%TCL%\include

@echo Build STI
msdev "STI\STI.dsw" /MAKE "TestMaster - Win32 %config%" /REBUILD /out "%OUTPUT%\STIBuild.txt"

@echo Build Soar-8.3
msdev "%soarver%\interface\SoarInterface.dsw" /MAKE "dll - Win32 %config%" /REBUILD /out "%OUTPUT%\SoarBuild.txt"

@echo Build VisualSoar
@cd "VisualSoar\Source"
@del edu\umich\visualsoar\*.class
javac edu\umich\visualsoar\VisualSoar.java

@echo Build VisualSoar jar file
@del visualsoar.jar
@rem *** BADBAD -- This collects too much at the moment ***
jar cvfm VisualSoar.jar meta-inf\manifest.mf -C . * > ..\..\%OUTPUT%\VSBuild.txt
@cd ..\..

@echo Copy results to release point

@rem For now, copy existing release from Soar and modify it.
@rem Later we should be able to build this directly from the source files.
@xcopy /s /q "windowsBase\%soarver%\*.*" "%OUTPUT%\%soarver%\*.*"
@xcopy /s /q "WindowsBase\vs\*.*" "%OUTPUT%\vs\*.*"

@rem Overwrite the relevant parts
@xcopy /Y /q "%soarver%\interface\*.dll" "%OUTPUT%\%soarver%\interface\*.dll"
@xcopy /Y /q "%soarver%\interface\*.dll" "%OUTPUT%\%soarver%\library\*.dll"
@xcopy /Y /q "%soarver%\library\tsi31" "%OUTPUT%\%soarver%\library\tsi31\"
@xcopy /Y /q "visualsoar\Source\VisualSoar.jar" "%OUTPUT%\vs\visualSoar.jar"

@rem Copy over STI files
@xcopy /q "STI\%config%\*.dll" "%OUTPUT%\STI\*.dll"
@xcopy /q "STI\%config%\*.exe" "%OUTPUT%\STI\*.exe"

@rem For Windows, copy STI DLLs into position where exe's will file them automatically
@xcopy /q "STI\%config%\libSTI*.dll" "%OUTPUT%\%soarver%\*.*"
@xcopy /q "STI\%config%\*.dll" "%OUTPUT%\vs\*.dll"

@echo Build completed

@goto done

:help1
@echo Syntax is "make-all-windows <version> where e.g. <version> = 020
goto done

:help2
@echo Need to set VC6, JDK, TCL and RELEASES in windows-env.bat
goto done

:done
@echo on
@set path=%svpath%
@set include=%svinc%
@set lib=%svlib%
